#version 330
//uniform mat4 MVP;
 // Notice that the "1" here equals the "1" in glVertexAttribPointer
// Input vertex data, different for all executions of this shader.
layout(location = 0) in vec3 vertexPosition_modelspace;
layout(location = 1) in vec2 uvPosition;
 
// Output data ; will be interpolated for each fragment.
out vec2 UV;

uniform mat4 modelMatrix;
uniform mat4 projectionMatrix;
uniform mat4 viewMatrix;

void main(){
 
   
    vec4 v = vec4(vertexPosition_modelspace,1); // Transform an homogeneous 4D vector, remember ?
    gl_Position =   projectionMatrix  * viewMatrix * modelMatrix * vec4(vertexPosition_modelspace, 1);
    // UV of the vertex. No special space for this one.
    UV = uvPosition;
}