#version 330

in vec2 fragTex;

uniform sampler2D colorTexture;
uniform sampler2D originalTexture;

uniform float bloomPower=5.0;

out vec4 fragColor;

void main()
{
	fragColor=texture(colorTexture, fragTex)*bloomPower + texture(originalTexture, fragTex);
}