#version 330 core
 
// Input vertex data, different for all executions of this shader.
layout(location = 0) in vec3 vertexPosition_modelspace;
uniform mat4 modelMatrix;
uniform mat4 projectionMatrix;
uniform mat4 viewMatrix;
// Values that stay constant for the whole mesh.
 
void main(){

 gl_Position =  projectionMatrix  * viewMatrix * modelMatrix * vec4(vertexPosition_modelspace,1);
}