#version 330

in vec2 fragTex;

uniform sampler2D colorTexture;
uniform int hp;
uniform int hpMax;

uniform float startX=0.05;
uniform float endX=0.2;
uniform float startY=0.94;
uniform float endY=0.97;

out vec4 fragColor;

void main()
{	
	vec4 tmpFragColor=texture(colorTexture, fragTex);
	float startXR = startX;
	float endXR = endX/hpMax * hp + startX;
	vec4 hpColor = vec4(0, 0, 255, 0.85);

	if((fragTex.x>=startXR) && (fragTex.x<=endXR) && (fragTex.y>=startY) && (fragTex.y<=endY))
		tmpFragColor+=hpColor;
	
	fragColor=tmpFragColor;
}