#version 330

in vec2 fragTex;

uniform sampler2D colorTexture;

out vec4 fragColor;

void main()
{
	vec3 textureColor = texture(colorTexture, fragTex).rgb;
	fragColor=vec4(textureColor,1.0);

	// invert colour of right-hand side
	 vec3 color;
	 if (fragTex.s >= 0.5) {
	color = 1.0 - texture (colorTexture, fragTex).rgb;
	 } else {
	color = texture (colorTexture, fragTex).rgb;
	 }
	 fragColor = vec4 (color, 1.0);
}

//hier das shader mit dem versuch, subroutines zu benutzen. man braucht wohl mindestens version 400.

//#version 400

/*in vec2 UV;
in vec3 n;
in vec4 eye;
in vec3 l_dir;
in vec4 amb;*/

/*in vec2 fragTex;

uniform sampler2D colorTexture;

out vec4 fragColor;

subroutine vec4 RenderPassType();
subroutine uniform RenderPassType RenderPass;

subroutine (RenderPassType)
vec4 pass1()
{
	vec3 color;
	 if (fragTex.s >= 0.5) {
	color = 1.0 - texture (colorTexture, fragTex).rgb;
	 } else {
	color = texture (colorTexture, fragTex).rgb;
	 }
	 return vec4 (color, 1.0);
}

subroutine (RenderPassType)
vec4 pass2()
{
	vec3 color;
	 if (fragTex.s >= 0.25) {
	color = 1.0 - texture (colorTexture, fragTex).rgb;
	 } else {
	color = texture (colorTexture, fragTex).rgb;
	 }
	 return vec4 (color, 1.0);
}

void main()
{
	vec3 textureColor = texture(colorTexture, fragTex).rgb;
	fragColor=vec4(textureColor,1.0);*/

	// invert colour of right-hand side
	/* vec3 color;
	 if (fragTex.s >= 0.5) {
	color = 1.0 - texture (colorTexture, fragTex).rgb;
	 } else {
	color = texture (colorTexture, fragTex).rgb;
	 }
	 fragColor = vec4 (color, 1.0);*/

	 /*fragColor = RenderPass();
}*/
