#version 330


//in vec4 eye;
//in vec3 l_dir;

noperspective in vec2 fragTex;

uniform sampler2D colorTexture;

//gute einstellungen, schmal und sternfrmig
uniform vec4 uScale = vec4(1,1,1,1);
uniform vec4 uBias = vec4(-0.99,-0.99,-0.99,-1.0);

//commit: "schaut jz recht vernuenftig aus"
/*uniform vec4 uScale = vec4(0.5,0.5,0.5,1);
uniform vec4 uBias = vec4(1,1,1,0);*/

//commit: "woah O_o"
/*uniform vec4 uScale = vec4(1,1,1,1);
uniform vec4 uBias = vec4(0.5,0.5,0.5,1);*/

//commit: "etwas eingegrenzt"		--> auch ziemlich ok, hnlich wie "gute einstellungen"
/*uniform vec4 uScale = vec4(0.05,0.05,0.05,0);
uniform vec4 uBias = vec4(-0.99,-0.99,-0.99,-1.0);*/

//commit: "nicht mehr ganz so schoen"		--> strker, aber wirkt nicht mehr so diagonal
/*uniform vec4 uScale = vec4(0.5,0.5,0.5,0);
uniform vec4 uBias = vec4(-0.5,-0.5,-0.5,0);*/

//???
/*uniform vec4 uScale = vec4(1,1,1,1);
uniform vec4 uBias = vec4(-0.5,-0.5,-0.5,-1);*/

out vec4 fragColor;

void main()
{
	//if(dot(eye.rgb, l_dir)>0.0)	//nur rendern, wenn lichtquelle sichtbar
		fragColor=max(vec4(0.0), texture(colorTexture, fragTex) + uBias) * uScale;
	//else
		//fragColor=texture(colorTexture, fragTex);
}
